/**
@example ExampleFileNames.cpp
How to split a full path into its components directory, base of filename and extension of the filename.
\todo Windows may need some more work regarding the drive, in particular for network drives \\machine\share
and forwad vs. backward slashes. 
@author Jan Woetzel
*/

#include <iostream>
#include "Base/Common/FileHandling.hh"

using namespace std;


int main(int argc,char** argv){
  cout<<"current work directory "<<BIAS::GetCwd()<<endl;

  string full("/this/is/a/directory/ThisIsABase.ext");
  string dir, base, ext;

  // command line arg given?
  if (argc>1) full=argv[1];

  cout<<"Splitting  "<<full<<" into: "<<endl;

  // run the function:
  BIAS::SplitName(full, dir, base, ext);

  cout<<"\tdir  '"<<dir <<"'"<<endl
    <<"\tbase '"<<base<<"'"<<endl
    <<"\text  '"<<ext <<"'"<<endl;


  return 0;
}

