#include <Base/Common/XMLIO.hh>
#include <Base/Debug/Debug.hh>
#include <Base/Common/XMLBase.hh>

using namespace BIAS;
using namespace std;

// ############### this is the test class with xml support ###############

#define  VERSIONOFTESTCLASS 0.37

class myTestClass: public XMLBase, Debug { 
public:
  virtual int XMLGetClassName(string& TopLevelTag, double& Version) const;
  virtual int XMLOut(const xmlNodePtr Node, XMLIO& XMLObject) const;
  virtual int XMLIn(const xmlNodePtr Node, XMLIO& XMLObject);
  virtual ~myTestClass();
  int thedata;
};

// ################## implementation (virtual functions)  ##################

myTestClass::~myTestClass() {}

int myTestClass::XMLGetClassName(std::string& TopLevelTag,
                                    double &Version) const {
  TopLevelTag = "myTestClass";
  Version = VERSIONOFTESTCLASS;
  return 0;
}

int myTestClass::XMLOut(const xmlNodePtr Node, XMLIO& XMLObject) const {
  XMLObject.addAttribute(Node, "theData", thedata);
  return 0;
}


int myTestClass::XMLIn(const xmlNodePtr Node, XMLIO& XMLObject) { 
  thedata = XMLObject.getAttributeValueInt(Node, "theData");
  return 0;
}

// ########################## a small example program #######################

int main (int /*argc*/, char ** /*argv*/)
{ 
  // output
  myTestClass x, y, z;
  x.thedata = 42;
  x.XMLWrite("backupofx.xml");
  string str;
  x.XMLWriteToString(str);
  cout << "xml in string:\n" << str << endl;
  // input
  y.XMLRead("backupofx.xml");
  z.XMLReadFromString(str);
  // check result
  int result(0);
  if (x.thedata == y.thedata && x.thedata == z.thedata)
    result=0;
  else 
    result=-1;

  cout
    <<"x.thedata="<<x.thedata<<endl
    <<"y.thedata="<<y.thedata <<endl
    <<"z.thedata="<<z.thedata <<endl
    <<"result="<<result<<endl;
  return result;
}
