/* 
This file is part of the BIAS library (Basic ImageAlgorithmS).

Copyright (C) 2003, 2004    (see file CONTACTS for details)
  Multimediale Systeme der Informationsverarbeitung
  Institut fuer Informatik
  Christian-Albrechts-Universitaet Kiel


BIAS is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
(at your option) any later version.

BIAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with BIAS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#include "MyDebug.hh"

using namespace BIAS;
using namespace std;

ExampleDebug::ExampleDebug() : Debug()
{
  _iMyInt=0;
  ResetDebugLevelFromGlobal();
}

ExampleDebug::~ExampleDebug()
{}


void ExampleDebug::ResetDebugLevelFromGlobal()
{
  if (GetGlobalDebugLevel()>100)
    SetDebugLevel(GetDebugLevel()|EXAMPLEDEBUG_TESTFLAG);
  if (GetGlobalDebugLevel()>200)
    SetDebugLevel(GetDebugLevel()|EXAMPLEDEBUG_TESTFLAG2);
}


void ExampleDebug::func()
{
  // do something
  for (register int i=0; i<3; i++){
    _iMyInt+=10;
    BIASDOUT(EXAMPLEDEBUG_TESTFLAG,"some output: "<<_iMyInt
             <<"  _liDebugLevel: "<<GetDebugLevel());
    BIASDOUT(EXAMPLEDEBUG_TESTFLAG2,"i: "<<i<<"\tBIASGlobalDebugLevel: "
             <<GetGlobalDebugLevel());
  }
}
