# Find PMDTec time of flight camera access include+library
# See www.PMDtec.de
#
# Birger Streckel

IF(USE_PMD)
  FIND_PATH(PMD_INCLUDE_DIR pmdmsdk.h
    ${PMD_ROOT_DIR}
    $ENV{PMD_ROOT_DIR}
    $ENV{PMD_DIR}
    )

  FIND_LIBRARY(PMD_LIBRARY 
    NAMES pmdaccess
    PATHS
    ${PMD_ROOT_DIR}
    $ENV{PMD_ROOT_DIR}
    $ENV{PMD_DIR}
    DOC "PMD library"
    )
ENDIF(USE_PMD)

IF(USE_PMDUSB)
  FIND_PATH(PMDUSB_INCLUDE_DIR PMDDll.h
    ${PMDUSB_ROOT_DIR}
    $ENV{PMD_ROOT_DIR}
    $ENV{PMD_DIR}
    )

  FIND_LIBRARY(PMDUSB_LIBRARY 
    NAMES PMDDll
    PATHS
    ${PMDUSB_ROOT_DIR}
    $ENV{PMDUSB_ROOT_DIR}
    $ENV{PMDUSB_DIR}
    DOC "PMDUSB library"
    )
ENDIF(USE_PMDUSB)


IF(PMD_INCLUDE_DIR)
  IF(PMD_LIBRARY)
    SET( PMD_FOUND TRUE )
    SET( PMD_LIBRARIES ${PMD_LIBRARY} )
  ENDIF(PMD_LIBRARY)
ENDIF(PMD_INCLUDE_DIR)

IF(PMDUSB_INCLUDE_DIR)
  IF(PMDUSB_LIBRARY)
    SET( PMDUSB_FOUND TRUE )
    SET( PMDUSB_LIBRARIES ${PMDUSB_LIBRARY} )
  ENDIF(PMDUSB_LIBRARY)
ENDIF(PMDUSB_INCLUDE_DIR)
