#include "CameraViewport.hh"
#include <Base/Common/W32Compat.hh>
#include <Base/Debug/Error.hh>

#include <iostream>

#ifdef BIAS_HAVE_OPENGL
#  include <Gui/biasgl.h>
#endif // BIAS_HAVE_OPENGL


using namespace std;
using namespace BIAS;


CameraViewport::CameraViewport()
{
  InitMembers();
}

CameraViewport::CameraViewport(const int vx0, const int vy0, const unsigned int vwidth, const unsigned int vheight )
: x0(vx0), y0(vy0), width(vwidth), height(vheight) 
{}

void CameraViewport::InitMembers()
{
  x0=y0=0;
  width=height=256;
}

double BIAS::CameraViewport::GetAspect() const
{
  BIASASSERT(height!=0);
  return width / height;
}


std::ostream & BIAS::CameraViewport::Print(std::ostream & os) const
{
  os<<"CameraViewport: "<<endl
    <<"x0     "<<x0<<endl
    <<"y0     "<<y0<<endl
    <<"width  "<<width<<endl
    <<"height "<<height<<endl
    ;
  return os;
}


#ifdef BIAS_HAVE_OPENGL
void BIAS::CameraViewport::DisplayGL() const
{
  glViewport(
    (GLint)x0
    ,(GLint)y0
    ,(GLsizei)width
    ,(GLsizei)height 
    );
}
#endif // BIAS_HAVE_OPENGL
