#include <bias_config.h>

#include <Base/Common/BIASpragma.hh>
#include <Base/Image/Image.hh>
#include <Base/Image/ImageIO.hh> 
#include <Base/Common/W32Compat.hh>

#include <Image/Camera.hh>

#include <wx/wx.h>

#ifdef BIAS_HAVE_UEYE
#  include <VideoSource/VideoSource_uEye.hh>
#endif

#ifdef BIAS_HAVE_DCAM
#  include <VideoSource/VideoSource_DCAM.hh>
#endif

#include <VideoSource/VideoSource_Base.hh>

#include <Gui/VideoSource_Controller.hh>

using namespace std;
using namespace BIAS;


class MyApp : public wxApp
{
public:
  virtual bool OnInit();
};

bool MyApp::OnInit()
{
  BIAS::Camera<unsigned char> grabimage,vidimage;

#ifdef BIAS_HAVE_DCAM
#ifdef WIN32
  VideoSource_uEye cam;
#else
  VideoSource_DCAM cam;
#endif
  //VideoSource* camPointer = &cam;

  cam.OpenDevice();
  cam.InitImage(grabimage);
  cam.PreGrab();

  VideoSource_Controller *frame = new VideoSource_Controller(&cam);

  frame->Show(TRUE);
  int i=0;
  while(i++<100){
    cam.GrabSingle(grabimage);
    grabimage.Display(true,10,DEFAULT_32to8_scale);
  }
#endif

  return TRUE;
}

IMPLEMENT_APP(MyApp)
