#include <Image/FFT2D.hh>
#include <Base/Image/Image.hh>
#include <Base/Image/ImageIO.hh>
#include <Base/Image/ImageConvert.hh>


using namespace std;
using namespace BIAS;


int main(int argc, char *argv[])
{

  if (argc<2 || argc > 3){
    cerr << argv[0] << "  <image> [image2]\n";
    return -1;
  }

  Image<unsigned char> im1, im1grey;

  if (ImageIO::Load(argv[1], im1)!=0){
    BIASERR("error loading image "<<argv[1]);
    return -2;
  } 
  
  ImageConvert::ToGrey(im1,im1grey);
  ImageIO::Write("0_Grey1",im1grey);

  FFT2D<unsigned char, float> fft;
  fft.Init(im1grey.GetWidth(),im1grey.GetHeight());

  Image<float> i,r;

  fft.Filter(im1grey,r,i);
  ImageIO::Write("1_Imaginaer1",i);
  ImageIO::Write("1_Real1",r);

  if(argc == 3){
    Image<unsigned char> im2, im2grey,res;
    Image<float> cps;
    if (ImageIO::Load(argv[2], im2)!=0){
      BIASERR("error loading image "<<argv[2]);
      return -2;
    }
    if((im1.GetWidth() != im2.GetWidth()) || 
       (im1.GetHeight() != im2.GetHeight())){
      BIASERR("images must have same size!");
      return -2;
    }
    ImageConvert::ToGrey(im2,im2grey);
    ImageIO::Write("0_Grey2",im2grey);

    fft.Filter(im2grey,r,i);
    ImageIO::Write("1_Imaginaer2",i);
    ImageIO::Write("1_Real2",r);
    //ImageIO::Write("1_Hanning2",im2grey);

    //fft.TransformPhase(im1grey,p);
    //fft.TransformAbs(im1grey,m);
    //fft.Normalize(m);
    //ImageIO::Write("2_M1",m);
    //ImageIO::Write("2_P1",p);
    //fft.TransformPhase(im2grey,p);
    //fft.TransformAbs(im2grey,m);
    //fft.Normalize(m);
    //ImageIO::Write("2_M2",m);
    //ImageIO::Write("2_P2",p);

    fft.CrossPowerSpectrum(im1grey,im2grey,cps);
    ImageIO::Write("2_CPS",cps);
    //ImageIO::Write("2_M_Norm",m);
    //fft.Normalize(cps);
    //fft.Normalize(cps);
    //ImageIO::Write("3_Normalized",cps);
    fft.TransformReverse(cps,res);
    ImageIO::Write("4_Resolution",res);

  }



/*
  // transform to 2-channel image for complex representation
  fft.Filter(imgrey,res);
  ImageIO::Write("1_FFT2D_Filter",res);
  fft.Normalize(res);
  ImageIO::Write("2_FFT2D_Normalized",res);
  fft.TransformReverse(res,imgrev);
  ImageIO::Write("3_FFT2D_Reversed",imgrev);
*/
/*
  // transform to 2 image (1 channel per image) for complex representation
  fft.Filter(im1grey,r1,r2);
  ImageIO::Write("4_FFT2D_real",r1);
  ImageIO::Write("5_FFT2D_im",r2);

  fft.Normalize(r1);
  fft.Normalize(r2);
  ImageIO::Write("6_FFT2D_real_norm",r1);
  ImageIO::Write("7_FFT2D_im_norm",r2);

  // transform to 1 image with 1 channel, magnitude and phase
  fft.TransformAbs(im1grey,res);
  ImageIO::Write("8_FFT2D_magnitude",res);
  fft.MultHanning(res);
  ImageIO::Write("8_FFT2D_magnitude_hanning",res);
  fft.Normalize(res);
  ImageIO::Write("8_FFT2D_magnitude_norm",res);

  fft.TransformPhase(im1grey,res);
  ImageIO::Write("9_FFT2D_phase",res);
  fft.Normalize(res);
  ImageIO::Write("9_FFT2D_phase_norm",res);
*/
  return 0;
}

