/// running this test is used for debugging Dart/ctest runtime paths, environment, ... 
/// @author Jan Woetzel

#ifdef WIN32
#  define _CRT_SECURE_NO_DEPRECATE
#  define _CRT_NONSTDC_NO_DEPRECATE
#endif

#include <iostream>
#include <string>
#include <stdlib.h> // getenv
#ifdef WIN32
#  include <direct.h> // getcwd
#else // WIN32
#  include <unistd.h> // getcwd
#endif // WIN32

using namespace std;

int main(int argc, char ** argv)
{
  if (argc>0)
    cout<<"started "<<argv[0]<<endl;
  int result=0;

  //
  // determine runtime path
  //
  string PATH=getenv("PATH");
  cout<<"-----"<<endl<<"PATH= "<<endl;

  // linewise for better readability:
  for (unsigned int i=0; i<PATH.size(); i++){
    switch (PATH[i]) {
#ifdef WIN32
      case ';': // Win separator
#else // WIN32
      case ':': // tcsh, bash separator
#endif // WIN32
        cout<<PATH[i]<<endl;
        break;
      default: 
        cout<<PATH[i];
    }
  }
  cout<<endl<<"-----"<<endl;



  //
  // determine current working directory
  //
  const int n(260); // _MAX_PATH
  char buffer[n];  memset(buffer,0,n);
  if (getcwd(buffer, n)==NULL){
    cout<<"Error, error: getcwd returned NULL"<<endl;
    result=-1; 
  } else {
    cout<<"cwd: "<<buffer<<endl<<"-----"<<endl;
  }

  // print the whole environment
  int sysres=0;
#ifdef WIN32
  sysres = system("set");
#else // WIN32
  sysres = system("printenv");
#endif // WIN32
  if (sysres != 0){
    cout<<"could not print complete env. result="<<result<<endl;
    return -2;
  }

  // ctest needs this for >1024 chars output: 
  cout<<endl<<"ctest needs: CTEST_FULL_OUTPUT"<<endl;

  return result;
}
