/** @example timeit.cpp
@brief Helper to emulate the Unix "time" command on WIN32 platforms. 
Measure the duration of the execution of a command=timean application run.
@author Jan Woetzel 2005 
*/

#include <stdlib.h>
#include <iostream>
#include <string>

#include <Base/Debug/TimeMeasure.hh>

using namespace std;
using namespace BIAS;


void foo(int){}

// JW
int main(int argc, char** argv)
{   
  if (argc<=1){
    cout<<"usage: "<<endl;
    if (argc>0) cout<<argv[0]<<" ";
    cout<<"<application.exe> [<paramters>] "<<endl;
    cout<<"example: timeit mapp.exe -myarg1"<<endl;
    return -1;
  }
  // variables:
  int result = 0;
  string command="";
  TimeMeasure timer1;

  // create command: 
  for (int i=1; i<argc; i++)
  {
    command+=argv[i];
    command+= " "; // delimiter
  }
  //cout<<"overhead: "<<timer1.MeasureOverhead()<<endl;      
  cout<<"timing: "<<command<<endl;

  // run timed application as system call: 
  timer1.Start();
  result = system( command.c_str() );


  //{ // timed code
  //  double d(1);
  //  for (unsigned int a=0; a< (unsigned int)(5.0* 4000./5.); a++){
  //    for (unsigned int b=0; b<10000; b++){
  //      d+=sin(1.0+1.1*d);
  //      d-=cos(2.0+1.2*d);
  //    }
  //  }
  //  Sleep(5000);
  //}

  timer1.Stop();

  if (result!=0){
    cout<<"could not run, result="<<result<<endl;
    return -2;
  } else {
    cout<<"timing successful. "<<endl;
    // display final timing result: 
    timer1.Print(cout);        
  }
  return 0;
}
