#ifndef _PMatrix3DData_hh_
#define _PMatrix3DData_hh_

#include <bias_config.h>

#include <string>

#include <Base/Math/Vector3.hh>
#include <Base/Math/Vector4.hh>
#include <Base/Math/RGBA.hh>


namespace BIAS {

  /** @class PMatrix3DData
  @brief stores important data for drawing a camera */
  class /*BIASUtils_EXPORT*/ PMatrix3DData {
  public:
    BIAS::Vector3<double> C;  ///< camera center in wcs
    BIAS::Vector3<double> UL; ///< upper left corner of image plane in wcs
    BIAS::Vector3<double> UR; ///< upper right corner of image plane in wcs
    BIAS::Vector3<double> LL; ///< lower left corner of image plane in wcs
    BIAS::Vector3<double> LR; ///< lower right corner of image plane in wcs
    BIAS::Vector3<double> PP; ///< principle point in wcs
    BIAS::Vector3<double> Up; ///< Up-Vector (V)

    BIAS::RGBAuc Color;       ///< RGBA color+opacity, 255=opaque, 0=transp.
    std::string name;
  };
} // end namespace


#endif // _PMatrix3DData_hh_

