#include <VideoSource/VideoSource_usbPMD.hh>
#include <Base/Image/ImageIO.hh>

#include <sstream>

using namespace std;
using namespace BIAS;

int main(int argc, char** argv)
{
  VideoSource_usbPMD cam;

  cam.SetBitFile("C:/Programme/z2D3D/Bitfiles/default.rbt");

  if (cam.OpenDevice() < 0) {
    BIASERR("Error initializing camera!!!");
    abort();
  }
  if (cam.SetShutter(0.05f) < 0) {
    BIASERR("Error setting shutter!!!");
    abort();
  }

  Camera<unsigned char> grey;
  Camera<float> depth, coeff;

  stringstream st("");

  int i=0;
  while (i<10) {
    i++;
    st << "temp" << i << ".mip";
    if (cam.GrabSingle(grey) < 0) {
      BIASERR("Grabbing went wrong!");
      return -1;
    }
    if (cam.GrabSingleDepth(depth) < 0) {
      BIASERR("No depthimage available!!!");
      return -1;
    }
    if (cam.GrabSingleModCoeff(coeff) < 0) {
      BIASERR("No depthimage available!!!");
      return -1;
    }
    ImageIO::Write(st.str(), grey);
    st.str(string(""));
    st << "tempDepth" << i << ".mip";
    ImageIO::Write(st.str(), depth);
    st.str(string(""));
    st << "tempCoeff" << i << ".mip";
    ImageIO::Write(st.str(), coeff);
    st.str(string(""));
  }

  return 0;
}