// Piranha.cpp: implementation of the CuEye class.
//
//////////////////////////////////////////////////////////////////////
//#include "stdafx.h"

#include "ueyeclass.hh"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CuEye::CuEye () 
{
  m_hu = 0;

}


CuEye::~CuEye ()
{
}


int CuEye::InitCamera (int nId)
{
  int nRet = IS_CANT_OPEN_DEVICE;
  HIDS hu = (HIDS) nId;

  if((m_hu == 0)) 
  {
    nRet = is_InitCamera (&hu,0);

    if (nRet == IS_SUCCESS)
    {
      m_hu = hu;
      // Disable Autoexit
      is_EnableAutoExit( m_hu, IS_DISABLE_AUTO_EXIT );
    }
    
     
  }
  

  return nRet;
}


int CuEye::ExitCamera ()
{
  int nRet = IS_CANT_CLOSE_DEVICE;

  if(m_hu != 0)
  {
    nRet = is_ExitCamera (m_hu);
    m_hu = 0;
  }

  return nRet;
}


int CuEye::SetErrorReport (int lMode)
{
  return is_SetErrorReport (m_hu, lMode);
}


int CuEye::GetErrorText (int lErr, char* pcErrText)
{
  return is_GetError(m_hu,&lErr,&pcErrText);
}
int CuEye::GetNumberOfCameras (int* plNumCameras)
{
  return is_GetNumberOfCameras (plNumCameras);
}


int CuEye::GetDllVersion (int* plDllVers)
{
  *plDllVers = is_GetDLLVersion();
  return IS_SUCCESS;
}


int CuEye::GetPciSlot (int* plSlot)
{
  if(plSlot != 0)
    *plSlot = 0;

  return IS_FUNCTION_NOT_SUPPORTED_YET;
}


int CuEye::GetIRQ (int* plIRQ)
{
  if(plIRQ != 0)
    *plIRQ = 0;

  return IS_FUNCTION_NOT_SUPPORTED_YET;
}


int CuEye::GetColorDepth (int* plBpp, int* plColFormat)
{
  return is_GetColorDepth (m_hu, plBpp, plColFormat);
}


int CuEye::CameraStatus (int lInfo, long lValue)
{
  return is_CameraStatus (m_hu, lInfo, (ULONG)lValue);
}


int CuEye::GetCameraType ()
{
  return is_GetCameraType (m_hu);
}


int CuEye::GetOsVersion ()
{
  return is_GetOsVersion ();
}


int CuEye::SetBrightness (int lBright)
{
  return is_SetBrightness (m_hu, lBright);
}


int CuEye::SetContrast (int lCont)
{
  return is_SetContrast (m_hu, lCont);
}


int CuEye::SetGamma (int lGamma)
{
  return is_SetGamma (m_hu, lGamma);
}


int CuEye::SetWhiteBalance( INT nMode )
{
  return is_SetWhiteBalance(m_hu, nMode);
}


int CuEye::SetWhiteBalanceMultipliers(double dblRed, double dblGreen, double dblBlue )
{
  return is_SetWhiteBalanceMultipliers(m_hu, dblRed, dblGreen, dblBlue);
}


int CuEye::SetColorMode (int lMode)
{
  return is_SetColorMode (m_hu, lMode);
}


int CuEye::InitEvent (HANDLE hEv, int nWhich)
{
  return is_InitEvent (m_hu, hEv, nWhich);
}


int CuEye::EnableEvent (int nWhich)
{
  return is_EnableEvent (m_hu, nWhich);
}


int CuEye::DisableEvent (int nWhich)
{
  return is_DisableEvent (m_hu, nWhich);
}


int CuEye::ExitEvent (int nWhich)
{
  return is_ExitEvent (m_hu, nWhich);
}


int CuEye::EnableMessage (int nWhich, HWND hwnd)
{
  return is_EnableMessage(m_hu, nWhich, hwnd);
}


int CuEye::EnableAutoExit (int nMode)
{
  return is_EnableAutoExit(m_hu, nMode);
}


int CuEye::SetImageSize (int lWidth, int lHeight)
{
  return is_SetImageSize (m_hu, lWidth, lHeight);
}


int CuEye::SetImagePos (int lPosX, int lPosY)
{
  return is_SetImagePos (m_hu, lPosX, lPosY);
}


int CuEye::SetDisplayMode (int Mode)
{
  return is_SetDisplayMode (m_hu, Mode);
}


int CuEye::SetDisplayWindow (HWND hWnd)
{
  return is_SetHwnd (m_hu, hWnd);
}


int CuEye::SetDisplayKeyColor (int lKeyCol)
{
  return is_SetKeyColor (m_hu, (lKeyCol & 0x00FF0000) >> 16, (lKeyCol & 0x0000FF00) >> 8, lKeyCol & 0x000000FF);
}


int CuEye::SetMainDisplayWindow (HWND hWnd)
{
  return is_SetParentHwnd (m_hu, hWnd);
}


int CuEye::UpdateDisplay ()
{
  return is_UpdateDisplay (m_hu);
}


int CuEye::CaptureVideo (int lWait)
{
  return is_CaptureVideo (m_hu, lWait);
}


int CuEye::StopLiveVideo (int lWait)
{
  return is_StopLiveVideo (m_hu, lWait);
}


int CuEye::FreezeVideo (int lWait)
{
	return is_FreezeVideo (m_hu, lWait);

}


int CuEye::SetCaptureMode (int lMode)
{
  return is_SetCaptureMode (m_hu, lMode);
}

int CuEye::SetEdgeEnhancement(int lMode)
{
  return is_SetEdgeEnhancement(m_hu, lMode);
}

int CuEye::AllocImageMem (int lWidth, int lHeight, int lBpp, char** ppcImgMem, int* plID)
{
  return is_AllocImageMem (m_hu, lWidth, lHeight, lBpp, ppcImgMem, plID);
}


int CuEye::FreeImageMem (char* pcMem, int lID)
{
  return is_FreeImageMem (m_hu, pcMem, lID);
}


int CuEye::SetImageMem (char* pcMem, int lID)
{
  return is_SetImageMem (m_hu, pcMem, lID);
}


int CuEye::GetActiveImageMem (char** ppcImgMem, int* plID)
{
  return is_GetActiveImageMem (m_hu, ppcImgMem, plID);
}

int CuEye::GetActSeqBuffer(char** ppcImgMem, int* plID){
  INT dummy;
  return is_GetActSeqBuf(m_hu, &dummy, ppcImgMem,ppcImgMem);
}

int CuEye::InquireImageMem (char* pcMem, int lID, int* plX, int* plY, int* plBpp, int* plPitch)
{
  return is_InquireImageMem (m_hu, pcMem, lID, plX, plY, plBpp, plPitch);
}


int CuEye::ReadTriggerPort (int* plIn)
{
  int nRet = IS_SUCCESS;

  if(plIn != 0)
    *plIn = is_SetExternalTrigger (m_hu, IS_GET_TRIGGER_INPUTS);
  else
    nRet = IS_NULL_POINTER;

  return nRet;
}



int CuEye::ReadDigitalPort (int* plIn)
{
  int nRet = IS_SUCCESS;

  if(plIn != 0)
    *plIn = is_SetIO (m_hu, IS_GET_IO);
  else
    nRet = IS_NULL_POINTER;

  return nRet;
}


int CuEye::WriteDigitalPort (int lOut)
{
  return is_SetIO (m_hu, lOut);
}


int CuEye::SetExternalTrigger (int lMode)
{
  return is_SetExternalTrigger (m_hu, lMode);
}


int CuEye::GetCameraInfo (BOARDINFO* pInfo)
{
  int nRet = IS_SUCCESS;

  if(pInfo != 0)
    nRet = is_GetBoardInfo (m_hu, pInfo);
  else
    nRet = IS_NULL_POINTER;

  return nRet;
}


int CuEye::ReadEEPROM (int lAdr, char* pcBuf, int lCount)
{
  int nRet = IS_SUCCESS;

  if(pcBuf != 0)
    nRet = is_ReadEEPROM (m_hu, lAdr, pcBuf, lCount);
  else
    nRet = IS_INVALID_PARAMETER;

  return nRet;
}


int CuEye::WriteEEPROM (int lAdr, char* pcBuf, int lCount)
{
  int nRet = IS_SUCCESS;

  if(pcBuf != 0)
    nRet = is_WriteEEPROM (m_hu, lAdr, pcBuf, lCount);
  else
    nRet = IS_INVALID_PARAMETER;

  return nRet;
}


int CuEye::SaveImage (char* pcFile)
{
  return is_SaveImage (m_hu, pcFile);
}


int CuEye::LoadImage (char* pcFile)
{
  return is_LoadImage (m_hu, pcFile);
}


int CuEye::SaveImageMem (char* pcFile, char* pcMem, int lID)
{
  return is_SaveImageMem (m_hu, pcFile, pcMem, lID);
}


int CuEye::RenderBitmap (int nMemID, HWND hwnd, int nMode)
{
  return is_RenderBitmap(m_hu, nMemID, hwnd, nMode);
}


int CuEye::SetScaler (int nMode)
{
  if(nMode)
    return is_SetScaler(m_hu, IS_SET_SCALER_ON, IS_SET_SCALER_ON);
  else
    return is_SetScaler(m_hu, IS_SET_SCALER_OFF, IS_SET_SCALER_OFF);
}


int CuEye::SetPixelClock(int nClock)
{
  return is_SetPixelClock(m_hu, nClock);
}


int CuEye::SetFrameRate(double dFr, double* pdFrNew)
{
  return is_SetFrameRate(m_hu, dFr, pdFrNew);
}


int CuEye::SetExposureTime(double EXP, double* newEXP )
{
  return is_SetExposureTime(m_hu, EXP, newEXP );
}

double CuEye::GetExposureTime()
{
  double newexp =0.0;
  is_SetExposureTime(m_hu, IS_GET_EXPOSURE_TIME, &newexp );
  return newexp;
}

int CuEye::SetGain(double gain)
{
    int ret =0;
    ret = is_SetHardwareGain(m_hu,(int)gain,IS_IGNORE_PARAMETER,IS_IGNORE_PARAMETER,IS_IGNORE_PARAMETER);
    return ret;
}

double CuEye::GetGain()
{
   return is_SetHardwareGain(m_hu,IS_GET_MASTER_GAIN,IS_IGNORE_PARAMETER,IS_IGNORE_PARAMETER,IS_IGNORE_PARAMETER);
}


int CuEye::Renumerate( int reserved )
{
  // return is_Renumerate( m_hu, reserved );
  return -1;
}


int CuEye::GetSensorInfo( PSENSORINFO pInfo )
{
  return is_GetSensorInfo( m_hu, pInfo );
}
